=== debian/changelog ===
clickhouse (18.16.1+ds-7.3build2) lunar; urgency=medium

  * Rebuild against latest tiff

 -- Jeremy Bicha <jbicha@ubuntu.com>  Sat, 04 Feb 2023 19:07:15 -0500

clickhouse (18.16.1+ds-7.3build1) lunar; urgency=medium

  * No-change rebuild against libcapnp-0.9.2

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 03 Feb 2023 16:20:48 +0000
