=== debian/control ===
Source: clickhouse
Section: database
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Alexander GQ Gerasiov <gq@debian.org>
Build-Depends: cmake,
               curl <!nocheck>,
               debhelper (>= 10),
               default-libmysqlclient-dev | libmysqlclient-dev,
               gdb <!nocheck>,
               googletest,
               libboost-dev,
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libboost-regex-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libcapnp-dev [!ia64],
               libcctz-dev,
               libcpuinfo-dev [amd64 arm64],
               libdouble-conversion-dev,
               libfarmhash-dev,
               libglib2.0-dev,
               libgoogle-perftools-dev [!sparc64 !x32],
               libgsasl7-dev,
               libicu-dev,
               libjemalloc-dev,
               libltdl-dev,
               liblz4-dev,
               libpoco-dev,
               librdkafka-dev,
               libre2-dev,
               libreadline-dev,
               libsparsehash-dev,
               libssl-dev,
               libzstd-dev,
               llvm-dev,
               openssl <!nocheck>,
               python3-lxml <!nocheck>,
               python3-requests <!nocheck>,
               python3-termcolor <!nocheck>,
               unixodbc-dev,
               zlib1g-dev,
	       libdivide-dev,
	       libpcg-cpp-dev,
	       libmetrohash-dev,
	       tzdata,
#	       libclang-dev,
#	       liblld-7-dev,
#needs newer version
#	       libunwind-dev (>= 1.3),
Standards-Version: 4.3.0
Homepage: https://clickhouse.yandex/
Vcs-Git: https://salsa.debian.org/debian/ClickHouse.git
Vcs-Browser: https://salsa.debian.org/debian/ClickHouse

Package: clickhouse-common
Architecture: any-amd64 ia64 arm64 ppc64el ppc64 s390x mips64el sparc64 riscv64 hppa
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: column-oriented database system (common files)
 ClickHouse is a column-oriented database management system that allows
 generating analytical data reports in real time.
 .
 This package provides common files for both ClickHouse server and client.

Package: clickhouse-server
Architecture: any-amd64 ia64 arm64 ppc64el ppc64 s390x mips64el sparc64 riscv64 hppa
Depends: ${misc:Depends}, ${shlibs:Depends}, clickhouse-common (= ${binary:Version}), adduser
Recommends: clickhouse-client (= ${binary:Version})
Description: column-oriented database system (server runner)
 ClickHouse is a column-oriented database management system that allows
 generating analytical data reports in real time.
 .
 This package provides ClickHouse server runner.

Package: clickhouse-client
Architecture: any-amd64 ia64 arm64 ppc64el ppc64 s390x mips64el sparc64 riscv64 hppa
Depends: ${misc:Depends}, ${shlibs:Depends}, clickhouse-common (= ${binary:Version})
Description: column-oriented database system (cli client)
 ClickHouse is a column-oriented database management system that allows
 generating analytical data reports in real time.
 .
 This package provides ClickHouse CLI client.

Package: clickhouse-tools
Architecture: any-amd64 ia64 arm64 ppc64el ppc64 s390x mips64el sparc64 riscv64 hppa
Depends: ${misc:Depends}, ${shlibs:Depends}, clickhouse-common (= ${binary:Version})
Description: column-oriented database system (tools)
 ClickHouse is a column-oriented database management system that allows
 generating analytical data reports in real time.
 .
 This package provides various ClickHouse tools:
  - clickhouse-performance-test
  - clickhouse-benchmark
  - clickhouse-compressor
  - clickhouse-copier
 and some others.
